Index: proj/libs/graph/include/graph.h
===================================================================
--- proj/libs/graph/include/graph.h	(revision 289)
+++ proj/libs/graph/include/graph.h	(revision 290)
@@ -13,6 +13,7 @@
 // Colors in RBG (8 bit)
 #define GRAPH_BLACK               0x000000
 #define GRAPH_WHITE               0xFFFFFF
+#define GRAPH_TRANSPARENT         0x00
 
 // Alpha
 #define ALPHA_THRESHOLD     0x7F
Index: proj/src/proj.c
===================================================================
--- proj/src/proj.c	(revision 289)
+++ proj/src/proj.c	(revision 290)
@@ -159,17 +159,15 @@
                             case TIMER0_IRQ:
                                 switch (game_state) {
                                 case MENU:
-                                    if (no_interrupts % 2 == 0){
-                                        graph_clear_screen();
-                                        game_state = menu_update_state(main_menu, click);
-                                        menu_draw(main_menu);
+                                    graph_clear_screen();
+                                    game_state = menu_update_state(main_menu, click);
+                                    menu_draw(main_menu);
 
-                                        click = 0;
+                                    click = 0;
 
-                                        sprite_set_pos(sp_crosshair, *mouse_x, *mouse_y);
-                                        sprite_draw(sp_crosshair);
-                                        graph_draw();
-                                    }
+                                    sprite_set_pos(sp_crosshair, *mouse_x, *mouse_y);
+                                    sprite_draw(sp_crosshair);
+                                    graph_draw();
                                     break;
                                 case GAME:
                                     if (no_interrupts % 60 == 0) timer_update(in_game_timer);
Index: proj/src/proj_func.c
===================================================================
--- proj/src/proj_func.c	(revision 289)
+++ proj/src/proj_func.c	(revision 290)
@@ -213,12 +213,15 @@
     rectangle_set_fill_color(ret->r0, GRAPH_BLACK);
     rectangle_set_outline_width(ret->r0, 2);
     rectangle_set_outline_color(ret->r0, GRAPH_WHITE);
+    rectangle_set_fill_trans(ret->r0, GRAPH_TRANSPARENT);
     rectangle_set_fill_color(ret->r1, GRAPH_BLACK);
     rectangle_set_outline_width(ret->r1, 2);
     rectangle_set_outline_color(ret->r1, GRAPH_WHITE);
+    rectangle_set_fill_trans(ret->r1, GRAPH_TRANSPARENT);
     rectangle_set_fill_color(ret->r2, GRAPH_BLACK);
     rectangle_set_outline_width(ret->r2, 2);
     rectangle_set_outline_color(ret->r2, GRAPH_WHITE);
+    rectangle_set_fill_trans(ret->r2, GRAPH_TRANSPARENT);
     text_set_valign(ret->t0, text_valign_center);
     text_set_halign(ret->t0, text_halign_center);
     text_set_color(ret->t0, TEXT_COLOR);
@@ -231,6 +234,7 @@
     rectangle_set_fill_color(ret->frame, GRAPH_BLACK);
     rectangle_set_outline_width(ret->frame, 6);
     rectangle_set_outline_color(ret->frame, GRAPH_WHITE);
+    rectangle_set_fill_trans(ret->frame, GRAPH_TRANSPARENT);
     // POSITIONS
     rectangle_set_pos(ret->r0,
                       graph_get_XRes()/2    - rectangle_get_w(ret->r0)/2,
Index: proj/Makefile
===================================================================
--- proj/Makefile	(revision 289)
+++ proj/Makefile	(revision 290)
@@ -9,7 +9,7 @@
 .PATH: ${.CURDIR}/libs/classes/src
 .PATH: ${.CURDIR}/libs/utils/src
 
-SRCS= proj.c list.c queue.c graph.c kbc.c keyboard.c mouse.c utils.c timer.c interrupts_func.c proj_func.c fast_math.c rectangle.c font.c xpm_utils.c ent.c rtc.c uart.c makecode_map.c
+SRCS= proj.c list.c queue.c graph.c kbc.c keyboard.c mouse.c utils.c timer.c interrupts_func.c proj_func.c fast_math.c rectangle.c font.c xpm_utils.c ent.c rtc.c uart.c hltp.c makecode_map.c
 IPATHS=-I./include -I./libs/graph/include -I./libs/kbc/include -I./libs/rtc/include -I./libs/timer/include -I./libs/uart/include -I./libs/classes/include -I./libs/utils/include -I./maps -I./media/xpm
 
 CPPFLAGS += -pedantic ${IPATHS} -D LCOM_MACRO #-D __LCOM_OPTIMIZED_